using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.IO;

namespace UltraComboIssue
{
    public partial class frmUltraComboIssue : Form
    {
        private int _loadExampleIndex;
        public frmUltraComboIssue()
        {
            InitializeComponent();
        }

        private void frmUltraComboIssue_Load(object sender, EventArgs e)
        {
            try
            {
                Cursor = Cursors.WaitCursor;
                //LoadData();
                LoadAutoCompleteModeCombo();
                
                
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                Cursor = Cursors.Default;
            }
        }

        private void LoadData()
        {
            

            if (_loadExampleIndex == 0)
            {
                DataSet dsData = new DataSet();
                dsData.ReadXml(Path.Combine(Application.StartupPath, "EINs.xml"));

                DataTable dtTemp = dsData.Tables[0].Clone();
                dtTemp.Columns.Add("EINIdValue", typeof(int));
                dtTemp.Columns["EINIdValue"].Expression = "CONVERT(EINId,'System.Int32')";
                dtTemp.Merge(dsData.Tables[0].Copy());
                ultraCombo1.DataSource = dtTemp.Copy();
                ultraCombo1.DisplayMember = "DECRYPTEINFLOC";
                ultraCombo1.ValueMember = "EINIdValue";

                ultraComboEditor1.DataSource = dtTemp.Copy();
                ultraComboEditor1.DisplayMember = "DecryptEINFLOC";
                ultraComboEditor1.ValueMember = "EINIdValue";
            }
            else
                LoadExample1Data();
            
        }
        private void LoadAutoCompleteModeCombo()
        {
            
            DataTable dtStyle = new DataTable("Style");
            dtStyle.Columns.Add("Name");
            dtStyle.Columns.Add("Mode", typeof(Infragistics.Win.AutoCompleteMode));

            DataRow dRow = dtStyle.NewRow();
            dRow[0] = "Default";
            dRow[1] = Infragistics.Win.AutoCompleteMode.Default;
            dtStyle.Rows.Add(dRow);

            dRow = dtStyle.NewRow();
            dRow[0] = "Append";
            dRow[1] = Infragistics.Win.AutoCompleteMode.Append;
            dtStyle.Rows.Add(dRow);

            dRow = dtStyle.NewRow();
            dRow[0] = "None";
            dRow[1] = Infragistics.Win.AutoCompleteMode.None;
            dtStyle.Rows.Add(dRow);

            dRow = dtStyle.NewRow();
            dRow[0] = "Suggest";
            dRow[1] = Infragistics.Win.AutoCompleteMode.Suggest;
            dtStyle.Rows.Add(dRow);

            dRow = dtStyle.NewRow();
            dRow[0] = "SuggestAppend";
            dRow[1] = Infragistics.Win.AutoCompleteMode.SuggestAppend;
            dtStyle.Rows.Add(dRow);

            ifgCboAutoCompleteMode.DisplayMember = "Name";
            ifgCboAutoCompleteMode.ValueMember = "BarStyle";
            ifgCboAutoCompleteMode.DataSource = dtStyle.DefaultView;
            ifgCboAutoCompleteMode.SelectedIndex = 2;

        }
        private void ifgBtnRefresh_Click(object sender, EventArgs e)
        {
            try
            {
                Cursor = Cursors.WaitCursor;
                _loadExampleIndex = 0;
                LoadData();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                Cursor = Cursors.Default;
            }
        }

        private void ifgCboAutoCompleteMode_ValueChanged(object sender, EventArgs e)
        {
            try
            {
                if (ifgCboAutoCompleteMode.SelectedIndex >= 0)
                {
                    LoadData();
                    if (ifgCboAutoCompleteMode.Text.Equals("None", StringComparison.InvariantCultureIgnoreCase))
                    {
                        ultraCombo1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.None;
                        ultraComboEditor1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.None;
                    }
                    else if (ifgCboAutoCompleteMode.Text.Equals("Default", StringComparison.InvariantCultureIgnoreCase))
                    {
                        ultraCombo1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.Default;
                        ultraComboEditor1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.Default;
                    }
                    else if (ifgCboAutoCompleteMode.Text.Equals("Append", StringComparison.InvariantCultureIgnoreCase))
                    {
                        ultraCombo1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.Append;
                        ultraComboEditor1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.Append;
                    }
                    else if (ifgCboAutoCompleteMode.Text.Equals("Suggest", StringComparison.InvariantCultureIgnoreCase))
                    {
                        ultraCombo1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.Suggest;
                        ultraComboEditor1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.Suggest;
                    }
                    else if (ifgCboAutoCompleteMode.Text.Equals("SuggestAppend", StringComparison.InvariantCultureIgnoreCase))
                    {
                        ultraCombo1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.SuggestAppend;
                        ultraComboEditor1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.SuggestAppend;
                    }
                    
                }
            }
            catch
            {

            }
        }

        private void ultraCombo1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //e.Layout.Override.AllowAddNew = AllowAddNew.TemplateOnBottom;
            
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            //e.Layout.Bands[0].Columns["bPrimary"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
            foreach (UltraGridBand ugBand in e.Layout.Bands)
            {
                foreach (UltraGridColumn ugColumn in ugBand.Columns)
                {
                    switch (ugColumn.Key.ToUpper())
                    {
                        case "VALUE":
                            ugColumn.Header.Caption = "EIN";
                            ugColumn.ExcludeFromColumnChooser = ExcludeFromColumnChooser.True;
                            ugColumn.Header.Fixed = true;
                            //oCol.Header.Caption = Resources.GridCaptions.DecryptEINFLOC;                                
                            break;
                        case "DECRYPTEINFLOC":
                            ugColumn.Header.Caption = "EIN";
                            ugColumn.ExcludeFromColumnChooser = ExcludeFromColumnChooser.True;
                            ugColumn.Header.Fixed = true;
                            //oCol.Header.Caption = Resources.GridCaptions.DecryptEINFLOC;                                
                            break;
                        case "EINIDVALUE":
                            ugColumn.Header.Caption = "EINID";
                            ugColumn.ExcludeFromColumnChooser = ExcludeFromColumnChooser.True;
                            ugColumn.Header.Fixed = true;
                            //oCol.Header.Caption = Resources.GridCaptions.DecryptEINFLOC;                                
                            break;
                        case "DECRYPTEINFLOCNAME":
                            ugColumn.Header.Caption = "EIN Name";
                            ugColumn.ExcludeFromColumnChooser = ExcludeFromColumnChooser.True;
                            //oCol.Header.Caption = Resources.GridCaptions.DecryptEINFLOCNAME;
                            ugColumn.Header.Fixed = true;
                            ugColumn.Hidden = true;
                            break;
                        default:
                            ugColumn.Hidden = true;
                            break;
                    }
                }
            }
        }

        private void ultraCombo1_ItemNotInList(object sender, Infragistics.Win.UltraWinEditors.ValidationErrorEventArgs e)
        {
            if (string.IsNullOrEmpty(ultraCombo1.Text.Trim()))
                return;
            string value = ultraCombo1.Text.Trim();
            DataTable dtTemp = ultraCombo1.DataSource as DataTable;
            DataRow tempRow = dtTemp.NewRow();
            if (_loadExampleIndex == 0)
            {
                
                object maxValue = dtTemp.Compute("Max(EINIdValue)", "1=1");
                int tempID = Convert.ToInt32(maxValue) + 1;
                
                tempRow["EINIdValue"] = tempID;
                tempRow["EINId"] = tempID.ToString();
                tempRow["DecryptEINFLOC"] = value;
                
            }
            else
            {
                tempRow["Value"] = value;                
            }
            dtTemp.Rows.Add(tempRow);
            dtTemp.AcceptChanges();
        }

        private void ultraComboEditor1_ItemNotInList(object sender, Infragistics.Win.UltraWinEditors.ValidationErrorEventArgs e)
        {
            if (string.IsNullOrEmpty(ultraComboEditor1.Text.Trim()))
                return;
            string value = ultraComboEditor1.Text.Trim();
            DataTable dtTemp = ultraComboEditor1.DataSource as DataTable;
            DataRow tempRow = dtTemp.NewRow();
            if (_loadExampleIndex == 0)
            {

                object maxValue = dtTemp.Compute("Max(EINIdValue)", "1=1");
                int tempID = Convert.ToInt32(maxValue) + 1;

                tempRow["EINIdValue"] = tempID;
                tempRow["EINId"] = tempID.ToString();
                tempRow["DecryptEINFLOC"] = value;

            }
            else
            {
                tempRow["Value"] = value;
            }
            dtTemp.Rows.Add(tempRow);
            dtTemp.AcceptChanges();
        }

        private void LoadExample1Data()
        {

            DataSet dsData = new DataSet();
            dsData.ReadXml(Path.Combine(Application.StartupPath, "SealDeviceTypes.xml"));

            DataTable dtExample1 = new DataTable();
            dtExample1.Columns.Add("ID", typeof(int));
            dtExample1.Columns["ID"].AutoIncrement = true;
            dtExample1.Columns["ID"].AutoIncrementSeed = 0;
            dtExample1.Columns["ID"].AutoIncrementStep = 1;
            dtExample1.Columns.Add("Value");

            //string[] strValues = new string[]{"Sample","4","Test","2","NEW","SAN"};
            DataRow dRow = null;
            foreach (DataRow dTestRow in dsData.Tables[0].Rows)
            {
                dRow = dtExample1.NewRow();
                dRow["Value"] = dTestRow[0];
                dtExample1.Rows.Add(dRow);
            }

            //DataRow dRow = null;
            //foreach (string str in strValues)
            //{
            //    dRow = dtExample1.NewRow();
            //    dRow["Value"] = str;
            //    dtExample1.Rows.Add(dRow);
            //}
            dtExample1.AcceptChanges();

            ultraCombo1.DataSource = dtExample1.Copy();
            ultraCombo1.DisplayMember = "Value";
            ultraCombo1.ValueMember = "ID";

            ultraComboEditor1.DataSource = dtExample1.Copy();
            ultraComboEditor1.DisplayMember = "Value";
            ultraComboEditor1.ValueMember = "ID";

            
        }
        private void btnExample_Click(object sender, EventArgs e)
        {
            _loadExampleIndex = 1;
            LoadExample1Data();
        }

        //private void LoadGrid()
        //{
        //    DataSet dsData = new DataSet();
        //    dsData.ReadXml(Path.Combine(Application.StartupPath, "EINSummary.xml"));
        //    ifgGridFrom.DataSource = dsData.Copy();

        //}

        //private void ifgDDSealDeviceType_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        //{
        //    try   //Code added By Vijay on 15/11/2008
        //    {
        //        Cursor = Cursors.WaitCursor;

        //    }

        //    catch (Exception ex) //Code added By Vijay on 15/11/2008
        //    {
                
        //    }

        //    finally //Code added By Vijay on 15/11/2008
        //    {
        //        Cursor = Cursors.Default;
        //    }

        //    e.Layout.Bands[0].Columns[0].Hidden = true;
        //    e.Layout.Bands[0].ColHeadersVisible = false;
        //    e.Layout.Bands[0].Columns[1].Width = ifgGridFrom.DisplayLayout.Bands[0].Columns["SealDeviceType"].Width;
        //    //sLocalizedGridCaption = Utils.GetLocalizedText(enumResourceType.GRID_CAPTION, "SealDeviceType");
        //    //e.Layout.Bands[0].Columns[1].Header.Caption = sLocalizedGridCaption.Trim() == string.Empty ? e.Layout.Bands[0].Columns[1].Key : sLocalizedGridCaption.Trim();

        //}
        //private void ifgGridFrom_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        //{
        //    try
        //    {
        //        foreach (UltraGridBand oBand in e.Layout.Bands)
        //        {
        //            foreach (UltraGridColumn oCol in oBand.Columns)
        //            {
                        
        //                //oCol.CellActivation = Activation.NoEdit;
        //                //Hide ID Columns

        //                switch (oCol.Key.ToUpper())
        //                {
        //                    case "FLUIDIDCASNO":
        //                        //oCol.Header.Caption = Resources.GridCaptions.FluidIdCASNo; //For Testing Team
        //                        break;
        //                    case "RHCOUNT":
        //                        //oCol.Header.Caption = Resources.GridCaptions.RHCount; //For Testing Team
        //                        break;
        //                    case "LEAKAGE":
        //                    case "EINID":
        //                    case "EQUIPMENTTYPEID":
        //                    case "LOCATIONID":
        //                    case "FACILITYID":
        //                    case "MANUFACTURERID":
        //                    case "MODELID":
        //                    case "EINDIMENSIONID":
        //                    case "EINDRIVERID":
        //                    case "DRIVERMANUFACTURERID":
        //                    case "DRIVERCOUPLINGMANUFACTURERID":
        //                    case "EINENVCONTROLID":
        //                    case "PIPINGPLANID":
        //                    case "UDF1":
        //                    case "UDF2":
        //                    case "UDF3":
        //                    case "UDF4":
        //                    case "EINPROCESSID":
        //                    case "EINHYDRAULICID":
        //                    case "FLUIDID":
        //                    case "FLUIDCASNO":
        //                    case "POWERENDMANUFACTURERID":
        //                    case "EIN_POWERENDID":
        //                    case "EIN_WETENDID":
        //                    case "EINFLOC":
        //                    case "EINFLOCNAME":
        //                    case "UNITOFMEASUREID":
        //                    case "SOLIDSHAFTSLEEVEID":
        //                        oCol.Hidden = true;
        //                        oCol.ExcludeFromColumnChooser = ExcludeFromColumnChooser.True;
        //                        break;
        //                    case "SEALDEVICETYPE":
        //                        //oCol.Header.Caption = Resources.GridCaptions.SealDeviceType;
        //                        oCol.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDown;
        //                        oCol.ValueList = ifgDDSealDeviceType;
        //                        break;
        //                }
        //            }
        //        }
        //    }
        //    catch
        //    {
        //    }
        //}
    }
}